<template>
  <div>
    <div class="blanco">
      <div class="gris">
        <AgrupadorRutas v-model="dataAgrupadorRutas" ref="agrupador-rutas" />
        <v-row>
          <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3">
            <v-btn class="mr-6" block tile color="white" @click="nuevaRuta"
              >+ Agregar ruta</v-btn
            >
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-simple-table
              light
              dense
              fixed-header
              height="200px"
              class="rutas"
              :class="{ 'error-validacion': $v.rutas.$error }"
            >
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">
                      <div class="subtitle-2">
                        <strong>Pre-visualización de la ruta</strong>
                      </div>
                    </th>
                    <th class="text-left">
                      <template v-if="$v.rutas.$error">
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div @click="$v.rutas.$reset()" v-close-popover>
                              <div v-if="!$v.rutas.required">
                                ¡No te olvides que mínimo es una ruta!
                              </div>
                            </div>
                          </template>
                        </v-popover>
                      </template>
                      <template v-if="!isUniqueValidation">
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div
                              @click="isUniqueValidation = !isUniqueValidation"
                              v-close-popover
                            >
                              ¡Las rutas deben de ser unicas!
                            </div>
                          </template>
                        </v-popover>
                      </template>
                    </th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="(ruta, indexRuta) in rutas" :key="indexRuta">
                    <td>
                      <v-breadcrumbs :items="ruta.breadcrumbs"></v-breadcrumbs>
                    </td>
                    <td>
                      <v-btn
                        color="red"
                        light
                        tile
                        x-small
                        right
                        class="ma-0 pa-0 white--text"
                        @click="deleteRuta(ruta)"
                      >
                        <v-icon small>mdi-delete</v-icon>
                      </v-btn>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </v-col>
        </v-row>
      </div>
    </div>
  </div>
</template>
<style scoped>
.error-validacion {
  border: 1px solid rgb(253, 81, 81);
}
.rutas .v-btn {
  float: right;
  height: 25px;
  cursor: pointer;
}
</style>
<script>
import { required } from "vuelidate/lib/validators";
import AgrupadorRutas from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/AgrupadorRutas.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const ruta = {
  idRuta: null,
  codificacion: null,
  pais: null,
  modelo: null,
  unidadNegocio: null,
  nivelPaso: null,
  nivelMacroproceso: null,
  nivelProceso: null,
  nivelElemento: null,
  breadcrumbs: [],
};
export default {
  name: "Component-Rutas",
  components: {
    AgrupadorRutas,
  },
  props: ["folio"],
  data() {
    return {
      dataAgrupadorRutas: {},
      rutas: [],
      isUniqueValidation: true,
    };
  },
  watch: {
    rutas: {
      deep: true,
      handler(val, prev) {
        this.isUniqueValidation = true;
      },
    },
  },
  validations: {
    rutas: {
      required,
    },
  },
  methods: {
    nuevaRuta() {
      let isValidRutas = this.isValidRutas();
      if (isValidRutas) {
        let newRuta = JSON.parse(JSON.stringify(ruta));
        newRuta.codificacion = this.dataAgrupadorRutas.dataCodificacion.value;
        newRuta.pais = this.dataAgrupadorRutas.dataPais.value;
        newRuta.modelo = this.dataAgrupadorRutas.dataModelo.value;
        newRuta.unidadNegocio = this.dataAgrupadorRutas.dataUnidadNegocio.value;
        newRuta.nivelPaso = this.dataAgrupadorRutas.dataNivelPaso.value;
        newRuta.nivelMacroproceso = this.dataAgrupadorRutas.dataNivelMacroproceso.value;
        newRuta.nivelProceso = this.dataAgrupadorRutas.dataNivelProceso.value;
        newRuta.nivelElemento = this.dataAgrupadorRutas.dataNivelElemento.value;
        newRuta.breadcrumbs.push({
          disabled: true,
          exact: true,
          text: newRuta.codificacion,
        });
        newRuta.breadcrumbs.push({
          disabled: true,
          exact: true,
          text: newRuta.pais.descripcion,
        });
        newRuta.breadcrumbs.push({
          disabled: true,
          exact: true,
          text: newRuta.modelo.descripcion,
        });
        newRuta.breadcrumbs.push({
          disabled: true,
          exact: true,
          text: newRuta.unidadNegocio.descripcion,
        });
        if (newRuta.nivelPaso.idArbol) {
          newRuta.breadcrumbs.push({
            disabled: true,
            exact: true,
            text: newRuta.nivelPaso.descripcion,
          });
        }
        if (newRuta.nivelMacroproceso.idArbol) {
          newRuta.breadcrumbs.push({
            disabled: true,
            exact: true,
            text: newRuta.nivelMacroproceso.descripcion,
          });
        }
        if (newRuta.nivelProceso.idArbol) {
          newRuta.breadcrumbs.push({
            disabled: true,
            exact: true,
            text: newRuta.nivelProceso.descripcion,
          });
        }
        if (newRuta.nivelElemento.idArbol) {
          newRuta.breadcrumbs.push({
            disabled: true,
            exact: true,
            text: newRuta.nivelElemento.descripcion,
          });
        }
        if (this.isUniqueRuta(newRuta)) {
          this.postRuta(newRuta);
        }
      }
    },
    isValidRutas() {
      if (this.$refs["agrupador-rutas"] && this.$refs["agrupador-rutas"].$v) {
        this.$refs["agrupador-rutas"].$v.$touch();
        return !this.$refs["agrupador-rutas"].$v.$invalid;
      }
      return false;
    },
    isUniqueRuta(newRuta) {
      let hashNewRuta = {
        idPais: newRuta.pais.idPais,
        idModelo: newRuta.modelo.idModelo,
        idUnidadNegocio: newRuta.unidadNegocio.idUnidadNegocio,
      };
      if (newRuta.nivelPaso.idArbol) {
        hashNewRuta.idNivelPaso = newRuta.nivelPaso.idArbol;
      }
      if (newRuta.nivelMacroproceso.idArbol) {
        hashNewRuta.idNivelMacroproceso = newRuta.nivelMacroproceso.idArbol;
      }
      if (newRuta.nivelProceso.idArbol) {
        hashNewRuta.idNivelProceso = newRuta.nivelProceso.idArbol;
      }
      if (newRuta.nivelElemento.idArbol) {
        hashNewRuta.idNivelElemento = newRuta.nivelElemento.idArbol;
      }
      let unique = true;
      for (let indexRuta in this.rutas) {
        let itemRuta = this.rutas[indexRuta];
        let hashRuta = {
          idPais: itemRuta.pais.idPais,
          idModelo: itemRuta.modelo.idModelo,
          idUnidadNegocio: itemRuta.unidadNegocio.idUnidadNegocio,
        };
        if (newRuta.nivelPaso.idArbol && itemRuta.nivelPaso) {
          hashRuta.idNivelPaso = itemRuta.nivelPaso.idArbol;
        }
        if (newRuta.nivelMacroproceso.idArbol && itemRuta.nivelMacroproceso) {
          hashRuta.idNivelMacroproceso = itemRuta.nivelMacroproceso.idArbol;
        }
        if (newRuta.nivelProceso.idArbol && itemRuta.nivelProceso) {
          hashRuta.idNivelProceso = itemRuta.nivelProceso.idArbol;
        }
        if (newRuta.nivelElemento.idArbol && itemRuta.nivelElemento) {
          hashRuta.idNivelElemento = itemRuta.nivelElemento.idArbol;
        }
        let isEquals = JSON.stringify(hashRuta) == JSON.stringify(hashNewRuta);
        if (isEquals) {
          unique = false;
          break;
        }
      }
      this.isUniqueValidation = unique;
      return unique;
    },
    getRutas() {
      const self = this;
      axios(
        "/modelo-negocio/folio-rutas-niveles/v1/" +
          this.folio.idFolio +
          "/compuestas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let rutas = data.resultado.rutas;
            rutas.forEach((itemRuta) => {
              let newRuta = JSON.parse(JSON.stringify(ruta));
              newRuta.idRuta = itemRuta.idRuta;
              newRuta.codificacion = itemRuta.codificacion.descripcion;
              newRuta.pais = itemRuta.pais;
              newRuta.modelo = itemRuta.modelo;
              newRuta.unidadNegocio = itemRuta.unidadNegocio;
              newRuta.breadcrumbs.push({
                disabled: true,
                exact: true,
                text: newRuta.codificacion,
              });
              newRuta.breadcrumbs.push({
                disabled: true,
                exact: true,
                text: newRuta.pais.descripcion,
              });
              newRuta.breadcrumbs.push({
                disabled: true,
                exact: true,
                text: newRuta.modelo.descripcion,
              });
              newRuta.breadcrumbs.push({
                disabled: true,
                exact: true,
                text: newRuta.unidadNegocio.descripcion,
              });
              if (itemRuta.modelosNegocio) {
                let modelosNegocio = itemRuta.modelosNegocio;
                modelosNegocio.forEach(
                  (itemModeloNegocio, indexModeloNegocio) => {
                    if (indexModeloNegocio == 0) {
                      newRuta.nivelPaso = itemModeloNegocio;
                    }
                    if (indexModeloNegocio == 1) {
                      newRuta.nivelMacroproceso = itemModeloNegocio;
                    }
                    if (indexModeloNegocio == 2) {
                      newRuta.nivelProceso = itemModeloNegocio;
                    }
                    if (indexModeloNegocio == 3) {
                      newRuta.nivelElemento = itemModeloNegocio;
                    }
                    newRuta.breadcrumbs.push({
                      disabled: true,
                      exact: true,
                      text: itemModeloNegocio.descripcion,
                    });
                  }
                );
              }
              self.rutas.push(newRuta);
            });
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },
    postRuta(newRuta) {
      const self = this;
      let body = {
        codificacion: newRuta.codificacion,
        idPais: newRuta.pais.idPais,
        idModelo: newRuta.modelo.idModelo,
        idUnidadNegocio: newRuta.unidadNegocio.idUnidadNegocio,
      };
      axios
        .post(
          "/modelo-negocio/folio-rutas/v1/" + this.folio.idFolio + "/rutas",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            let idRuta = data.resultado.id;
            newRuta.idRuta = idRuta;
            self.rutas.push(newRuta);
            self.postRutaNivel(idRuta, "nivelPaso", newRuta);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    postRutaNivel(idRuta, tipoNivel, newRuta) {
      if (newRuta[tipoNivel].idArbol) {
        const self = this;
        let body = {
          idModeloNegocio: newRuta[tipoNivel].idArbol,
        };
        axios
          .post(
            "/modelo-negocio/folio-rutas-niveles/v1/" +
              this.folio.idFolio +
              "/rutas/" +
              idRuta +
              "/niveles",
            body
          )
          .then((response) => {
            let data = response.data;
            if (data) {
              if (tipoNivel === "nivelPaso") {
                self.postRutaNivel(idRuta, "nivelMacroproceso", newRuta);
              } else if (tipoNivel === "nivelMacroproceso") {
                self.postRutaNivel(idRuta, "nivelProceso", newRuta);
              } else if (tipoNivel === "nivelProceso") {
                self.postRutaNivel(idRuta, "nivelElemento", newRuta);
              }
            }
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          });
      }
    },
    deleteRuta(rutaToDelete) {
      const self = this;
      axios
        .delete(
          "/modelo-negocio/folio-rutas/v1/" +
            this.folio.idFolio +
            "/rutas/" +
            rutaToDelete.idRuta
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.deleteRutaNiveles(rutaToDelete);
            self.rutas = self.rutas.filter(
              (itemRuta) => itemRuta.idRuta !== rutaToDelete.idRuta
            );
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteRutaNiveles(rutaNivelToDelete) {
      const self = this;
      axios
        .delete(
          "/modelo-negocio/folio-rutas-niveles/v1/" +
            this.folio.idFolio +
            "/rutas/" +
            rutaNivelToDelete.idRuta +
            "/niveles/0"
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.rutas = self.rutas.filter(
              (itemRuta) => itemRuta.idRuta !== rutaNivelToDelete.idRuta
            );
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  created() {
    this.getRutas();
  },
};
</script>
